/* -*- mode:prolog; -*-
 ******************************************************************
 * $Id$
 * Copyright (C) 2008 by INRIA 
 * Author: Eric de la Clergerie <Eric.De_La_Clergerie@inria.fr>
 * ----------------------------------------------------------------
 *
 *  regexp.pl -- moteur pour les expressions rgulires en DyALog
 *
 * ----------------------------------------------------------------
 * Description
 * 
 * ----------------------------------------------------------------
 */

%% Import de la bibliothque DyALog pour l'impression
:-require 'format.pl'.

%% Dclaration des oprateurs pour construire les regexp
:-op(yf,['@?'],500).
:-op(yf,['@+'],500).
:-op(yf,['@*'],500).


%% Destructurer les constructeurs de regexp

%% Concatnation
regexp((E1,E2),L,R) :-
	regexp(E1,L,M),
	regexp(E2,M,R).

%% Disjunction
regexp((E1;E2),L,R) :-
	( regexp(E1,L,R)
	;
	  regexp(E2,L,R)
	)
	.

%% toile de Kleene
regexp(E @*,L,R) :-
	( L=R ;
	  regexp(E,L,M),
	  regexp(E @*,M,R)
	).

%% toile de Kleene stricte
regexp(E @+,L,R) :-
	regexp(E,L,M),
	regexp(E @*,M,R).

%% Deux forme pour epsilon
regexp(true,L,L).
regexp([],L,L).

%% Les expressions de base
regexp(c(C),L,R) :- 'C'(L,C,R).
regexp(range(Range),[C|R],R) :- domain(C,Range).
regexp(E @?,L,R) :- regexp((true;E),L,R).

%% Rien n'empche d'ajouter des expressions de debug
regexp(debug(Msg),L,L) :-
	format('~w at ~w\n',[Msg,L]).


%% Le lecteur sur liste (en complment du lecteur sur treillis de mots)
:-extensional 'C'/3.
'C'([C|R],C,R).

%% Le prdicat base de donnes pour accder aux regexp
:-extensional rx/2.

%% Une requte possible
%% Lecture sur une liste prolog de symboles
?- argv([Name|L]),
   rx(Name,RX),
   regexp(RX,L,[]).



